#ifndef CONSTRAINTDB_HPP_
#define CONSTRAINTDB_HPP_
#define simplyfire_hpp_version "$Revision: 1.33 $"

#include    "Satistics.hpp"
#include	"ThreadGlobals.hpp"
#include    "Types.hpp"
#include    "Settings.hpp"
#include    <vector>
#include	<list>
#include 	"Assertion.hpp"
#include 	"BitVector.hpp"

#include 	"VecOfLists.hpp"
#include 	"Hash.hpp"

#include	"Heap.hpp"
#include	"Queue.hpp"
#include	"Logging.hpp"
#include	"IFStream.hpp"
#include	"AssignInfos.hpp"
#include	"Watching.hpp"
#include	"ExtCls.hpp"
#include	"SCC.hpp"
#include	"Assym.hpp"
#include	"ElimProduct.hpp"
#include "Types.hpp"

using std::vector;

//#define PRINT_ELIM_SUB 1


struct OccCls{
	uint32_t cli	:31;
	uint32_t pol	:1;
	OccCls(const ECP& ep,const bool polarity):
		cli(ep.idx),pol(polarity){asrt(ep.idx<(1<<30));}
	ECP  getECP() const	{return ECP(cli);}
	bool isPosOcc() const	{return pol;}
};

class OccCount{
	uint16_t cnt[2];
public:
	OccCount(){cnt[0]=cnt[1]=0;}
	uint16_t& getOcc(const bool posi){	return cnt[posi];}
	uint32_t  product()const{			return (uint32_t)cnt[0] * (uint32_t)cnt[1];}
	uint32_t  sum()const	{			return (uint32_t)cnt[0] + (uint32_t)cnt[1];}
	friend bool operator==(const OccCount& a ,const OccCount& b);
	friend bool operator!=(const OccCount& a ,const OccCount& b);
};

inline bool operator==(const OccCount& a ,const OccCount& b){
	return (a.cnt[0] == b.cnt[0]) && (a.cnt[1] == b.cnt[1]);}

inline bool operator!=(const OccCount& a ,const OccCount& b){
	return (a.cnt[0] != b.cnt[0]) || (a.cnt[1] != b.cnt[1]);}

struct OccCountCompare{
	bool better(const OccCount& a,const OccCount& b)const{
		return a.product()<b.product();}
};


class SimplyFire{
	//global infos
	TGlobals&				glob;
	vector<Literal>&		units_out;
	BitVector<Variable>& 	var_flgs;



//general
protected:
	uint32_t				uq_begin;
	BitVector<Literal>		lit_flgs;

	vector<Literal>			clean_lits;

	vector<Subsumd> 		for_deletion;
	vector<Literal>			units_unpropd;
	vector<uint64_t>		algo_space; //is used in scc and assym checks and var elim and blocked cls check

	VarVal					vals;

	ExtClses					clses;
	VecOfLists<OccCls,Variable> var_occs;
	VecOfLists<EWtch,Literal>	wtching;


	bool						propagate(Literal lit, vector<Literal>& clean);
	bool						propagateUnpropdUnits();
	void						enqueue(const Literal& lit){asrt(vals.litUkwn(lit));
								vals.setValue(lit);	units_out.push_back(lit);}
	void						registerOcc(const Literal& w1, const Literal& w2, const ECP& ecp, Cls& cls,const bool lnrt);
	void						addOcc(const Literal& to, const ECP& ecp, const bool lrnt);
	int32_t						removeFalseLits(Cls& cls, const Literal& w1, const Literal& w2, signt_t& signat, bool& shrinkd);
	void						addAllLitsBut(const ECP& ecp,const Variable& ignore, vector<Literal>& out);
	ECP							newCls(Literal lits[], const uint32_t sz, bool lrnt, const uint32_t lbd, bool enq, bool assym);

	uint32_t					removeLit(ECP& ecp, const Literal& lit);
	void						cleanOccs(const Variable& var);
	void						cleanWtches(const Literal& lit);
	bool						delClses();
	void						addBinsSetFlgs(const Literal& lit, vector<Literal>& out);
	void						cleanBinsAndFlgs(vector<Literal>& lits);


	void 						incElimHp(const Literal& l);
	void 						decElimHp(const Literal& l);
	void						ensureFix(ExtCls& ec);
	void						ensureFix(ECP& ecp){if(ecp.idx!=max32)ensureFix(clses.getECls(ecp));}

/********************
 * Replace equal variables
 *********************/

	SCC 	scc;
	void 	updateBinsDontClean(SCC& scc, const Literal& lit,vector<Literal>& units_out);
	void 	updateBins(SCC& scc, const Literal& lit,vector<Literal>& units_out);
	void 	mergeBinLists(SCC& scc,const Literal& survive, list<Literal>& die, const bool first,vector<Literal>& units_out,vector<Variable>& update);
	bool 	replaceSCCs(SCC& scc, list<list<Literal> >& sccs, vector<Literal>& units_out);
	void 	replAux(const Literal& lit, vector<Literal>& old_lits,vector<Literal>& new_lits);

/********************
 * Var elimination
 *********************/
	Heap<Variable,OccCount,OccCountCompare>		elim_hp;


	static uint32_t getStrtForFakt2(const uint32_t& fact1_sz, const uint32_t& f2){
		return fact1_sz*f2;}

	static vector<Literal>* getStartForFakt2(vector<vector<Literal> >& vecs, const uint32_t& fact1_sz, const uint32_t& f2){
		return &vecs[getStrtForFakt2(fact1_sz,f2)];}


	/*static vector<Literal>& getProd(vector<Literal> vecs[], const uint32_t& fact1sz, const uint32_t& f1, const uint32_t& f2){
		return getAllOfFakt2(vecs,fact1sz,f2)[f1];}*/


	//blocked clause and var elimination
	uint32_t splitFixClses(const Variable& var,vector<FaktCls> split[], const uint32_t& max_lits);
	uint32_t splitBinsHlpr(const Literal& a, vector<FaktCls>& add);
	uint64_t initFakt1Lits(const vector<FaktCls>& fakt1, vector<Literal>& contained);

	void	setMsk(const Literal& l, const uint64_t& m, vector<Literal>& cont){ asrt(l.idx()<algo_space.size());
				if(lit_flgs.setFlagNew(l)){cont.push_back(l); algo_space[l.idx()] = m;}
				else{algo_space[l.idx()] |= m;}}
	uint64_t getMsk(const Literal& l){asrt(l.idx()<algo_space.size());
				return set_all(lit_flgs.isSet(l)) & algo_space[l.idx()];}

	void 	bwSelf(FaktCls& fcls, const Literal& rem);


	//var elimination
	void	 addFaktIf(const Literal& lit, uint64_t& add_cands, uint64_t& no_tauts, vector<Literal> fakt1[], const Variable& ignore);
	void 	addFakt2Lits(const vector<FaktCls>& fakt2, const uint64_t& all_msk, vector<vector<Literal> >& cross, const uint32_t& sz1, const Variable& ignore);
	bool   elimVarIf(const Variable& var, ElimProcut& eli_prod, const Literal& f1Lit, vector<FaktCls>& fakt1, const Literal& f2Lit,vector<FaktCls>& fakt2,
				const uint32_t& max_prod, bool assym);
	void 	elimBlockdIf(vector<FaktCls>& cands, const Literal& anc);
	void	finallyEliminate(const Variable& var);
	void 	elimBins(const Literal& lit,vector<Literal>& out);

//blocked clause elimination
	void 	initFakt2If(const Literal& lit, uint64_t& add_cands, uint64_t& no_tauts, TwoBitsVec<uint32_t>& cross, uint32_t fakt1_strt, const Variable& ignore);
	void 	initFakt2Lits(const vector<FaktCls>& fakt2, const uint64_t& all_msk, TwoBitsVec<uint32_t>& cross, const uint32_t& sz1, const Variable& ignore);
	bool   blockedCheckVar(const Variable& var, ElimProcut& eli_prod, const Literal& f1Lit, vector<FaktCls>& fakt1, const Literal& f2Lit,vector<FaktCls>& fakt2);
/********************
 * Assym checks
 *********************/
	Assym	assy;
	void	keepMarkdVars(ECP& ecp, const uint32_t& sz);
	void	keepMrkdAux(const Literal& lit, uint32_t& nsz, Literal nw[], ClsLit*& cp, signt_t& sig);
	bool 	productAssymCheck(vector<FiniProd>& prod);

/********************
 * Subsumption
 *********************/
	Literal chkSuperOrEqToMarked(const uint32_t& sub_sig, uint32_t sub_marked, ExtCls& super_cand);
	Literal chkSuperToBins(const Literal& sub_bin, const signt_t& bins_msk, ExtCls& super_cand, const bool allow_flpd);
	void	  collectSubsumed(const ECP& subp);
	void	  collectBinSubsumed(const Literal& lit);
	void	  removeVarInAux(const Variable& v, vector<ECP>& v_cls);
public:
	SimplyFire(TGlobals& globals,const VarVal& prev_vals,const var_hp_t& v_act_hp,vector<Literal>& units_out,BitVector<Variable>& flgs);
	void initSimpl(Watching& wtch,const uint32_t& assym_permil, const bool enq_all, const bool enq_lrnts_and_chnd);
	void getSimplResult(Watching& wtch);
	bool replaceSCCs();
	bool assymChecks(const bool blckd_chk);
	bool subsumCheck(uint32_t& cnt);
	bool elim(const bool blkd_chk, uint32_t& cnt);
	bool elimAndSubsum(const bool blkd_chk);


protected:
	bool asrtWatchingOK()const;
	uint32_t asrtWatchingCount(const Literal& a, const EWtch& ew)const;
	bool asrtKnownCount(const list<Literal>& scc, const uint32_t cnt);
	bool asrtReplCount(const list<Literal>& scc, const uint32_t cnt);
	bool	asrtBinNoElims() const ;
	void printBinaries()const;
	bool asrtOccCountOf(const Variable& var);
	bool asrtOccCount(const uint32_t& ignore = max32);
	bool asrtClsContains(ECP ecp, ExtCls& ec, const Literal& who);
	bool asrtPrintCls(const ECP& e, string what, int val);
	bool asrtOccsContain(const Literal& l, const ECP& e);
	bool asrtOccsContainCls( const ECP& e);
	bool asrtOccsContainAll();

};




const char*  simplyfire_cpp_version();




#endif /*CONSTRAINTDB_HPP_*/

